<?php
/**
 * CalculateBasketItem
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\BasketsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Baskets
 *
 * Ensi Baskets
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\BasketsClient\Dto;

use \ArrayAccess;
use \Ensi\BasketsClient\ObjectSerializer;

/**
 * CalculateBasketItem Class Doc Comment
 *
 * @category Class
 * @package  Ensi\BasketsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class CalculateBasketItem implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'CalculateBasketItem';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'offer_id' => 'int',
        'product_id' => 'int',
        'name' => 'string',
        'code' => 'string',
        'barcode' => 'string',
        'vendor_code' => 'string',
        'type' => 'int',
        'is_adult' => 'bool',
        'uom' => 'int',
        'tariffing_volume' => 'int',
        'order_step' => 'float',
        'order_minvol' => 'float',
        'main_image' => 'string',
        'qty' => 'float',
        'stock_qty' => 'int',
        'price' => 'int',
        'price_per_one' => 'int',
        'cost' => 'int',
        'cost_per_one' => 'int',
        'discount' => 'int',
        'discount_per_one' => 'int',
        'discounts' => '\Ensi\BasketsClient\Dto\Discount[]',
        'images' => '\Ensi\BasketsClient\Dto\ProductImage[]',
        'brand' => '\Ensi\BasketsClient\Dto\Brand',
        'nameplates' => '\Ensi\BasketsClient\Dto\Nameplate[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'offer_id' => null,
        'product_id' => null,
        'name' => null,
        'code' => null,
        'barcode' => null,
        'vendor_code' => null,
        'type' => null,
        'is_adult' => null,
        'uom' => null,
        'tariffing_volume' => null,
        'order_step' => null,
        'order_minvol' => null,
        'main_image' => null,
        'qty' => null,
        'stock_qty' => null,
        'price' => null,
        'price_per_one' => null,
        'cost' => null,
        'cost_per_one' => null,
        'discount' => null,
        'discount_per_one' => null,
        'discounts' => null,
        'images' => null,
        'brand' => null,
        'nameplates' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'offer_id' => false,
        'product_id' => false,
        'name' => false,
        'code' => false,
        'barcode' => true,
        'vendor_code' => true,
        'type' => false,
        'is_adult' => true,
        'uom' => true,
        'tariffing_volume' => true,
        'order_step' => true,
        'order_minvol' => true,
        'main_image' => true,
        'qty' => false,
        'stock_qty' => false,
        'price' => false,
        'price_per_one' => false,
        'cost' => false,
        'cost_per_one' => false,
        'discount' => false,
        'discount_per_one' => false,
        'discounts' => false,
        'images' => false,
        'brand' => false,
        'nameplates' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'offer_id' => 'offer_id',
        'product_id' => 'product_id',
        'name' => 'name',
        'code' => 'code',
        'barcode' => 'barcode',
        'vendor_code' => 'vendor_code',
        'type' => 'type',
        'is_adult' => 'is_adult',
        'uom' => 'uom',
        'tariffing_volume' => 'tariffing_volume',
        'order_step' => 'order_step',
        'order_minvol' => 'order_minvol',
        'main_image' => 'main_image',
        'qty' => 'qty',
        'stock_qty' => 'stock_qty',
        'price' => 'price',
        'price_per_one' => 'price_per_one',
        'cost' => 'cost',
        'cost_per_one' => 'cost_per_one',
        'discount' => 'discount',
        'discount_per_one' => 'discount_per_one',
        'discounts' => 'discounts',
        'images' => 'images',
        'brand' => 'brand',
        'nameplates' => 'nameplates'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'offer_id' => 'setOfferId',
        'product_id' => 'setProductId',
        'name' => 'setName',
        'code' => 'setCode',
        'barcode' => 'setBarcode',
        'vendor_code' => 'setVendorCode',
        'type' => 'setType',
        'is_adult' => 'setIsAdult',
        'uom' => 'setUom',
        'tariffing_volume' => 'setTariffingVolume',
        'order_step' => 'setOrderStep',
        'order_minvol' => 'setOrderMinvol',
        'main_image' => 'setMainImage',
        'qty' => 'setQty',
        'stock_qty' => 'setStockQty',
        'price' => 'setPrice',
        'price_per_one' => 'setPricePerOne',
        'cost' => 'setCost',
        'cost_per_one' => 'setCostPerOne',
        'discount' => 'setDiscount',
        'discount_per_one' => 'setDiscountPerOne',
        'discounts' => 'setDiscounts',
        'images' => 'setImages',
        'brand' => 'setBrand',
        'nameplates' => 'setNameplates'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'offer_id' => 'getOfferId',
        'product_id' => 'getProductId',
        'name' => 'getName',
        'code' => 'getCode',
        'barcode' => 'getBarcode',
        'vendor_code' => 'getVendorCode',
        'type' => 'getType',
        'is_adult' => 'getIsAdult',
        'uom' => 'getUom',
        'tariffing_volume' => 'getTariffingVolume',
        'order_step' => 'getOrderStep',
        'order_minvol' => 'getOrderMinvol',
        'main_image' => 'getMainImage',
        'qty' => 'getQty',
        'stock_qty' => 'getStockQty',
        'price' => 'getPrice',
        'price_per_one' => 'getPricePerOne',
        'cost' => 'getCost',
        'cost_per_one' => 'getCostPerOne',
        'discount' => 'getDiscount',
        'discount_per_one' => 'getDiscountPerOne',
        'discounts' => 'getDiscounts',
        'images' => 'getImages',
        'brand' => 'getBrand',
        'nameplates' => 'getNameplates'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('offer_id', $data, null);
        $this->setIfExists('product_id', $data, null);
        $this->setIfExists('name', $data, null);
        $this->setIfExists('code', $data, null);
        $this->setIfExists('barcode', $data, null);
        $this->setIfExists('vendor_code', $data, null);
        $this->setIfExists('type', $data, null);
        $this->setIfExists('is_adult', $data, null);
        $this->setIfExists('uom', $data, null);
        $this->setIfExists('tariffing_volume', $data, null);
        $this->setIfExists('order_step', $data, null);
        $this->setIfExists('order_minvol', $data, null);
        $this->setIfExists('main_image', $data, null);
        $this->setIfExists('qty', $data, null);
        $this->setIfExists('stock_qty', $data, null);
        $this->setIfExists('price', $data, null);
        $this->setIfExists('price_per_one', $data, null);
        $this->setIfExists('cost', $data, null);
        $this->setIfExists('cost_per_one', $data, null);
        $this->setIfExists('discount', $data, null);
        $this->setIfExists('discount_per_one', $data, null);
        $this->setIfExists('discounts', $data, null);
        $this->setIfExists('images', $data, null);
        $this->setIfExists('brand', $data, null);
        $this->setIfExists('nameplates', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['offer_id'] === null) {
            $invalidProperties[] = "'offer_id' can't be null";
        }
        if ($this->container['product_id'] === null) {
            $invalidProperties[] = "'product_id' can't be null";
        }
        if ($this->container['name'] === null) {
            $invalidProperties[] = "'name' can't be null";
        }
        if ($this->container['code'] === null) {
            $invalidProperties[] = "'code' can't be null";
        }
        if ($this->container['barcode'] === null) {
            $invalidProperties[] = "'barcode' can't be null";
        }
        if ($this->container['type'] === null) {
            $invalidProperties[] = "'type' can't be null";
        }
        if ($this->container['is_adult'] === null) {
            $invalidProperties[] = "'is_adult' can't be null";
        }
        if ($this->container['uom'] === null) {
            $invalidProperties[] = "'uom' can't be null";
        }
        if ($this->container['tariffing_volume'] === null) {
            $invalidProperties[] = "'tariffing_volume' can't be null";
        }
        if ($this->container['order_step'] === null) {
            $invalidProperties[] = "'order_step' can't be null";
        }
        if ($this->container['order_minvol'] === null) {
            $invalidProperties[] = "'order_minvol' can't be null";
        }
        if ($this->container['main_image'] === null) {
            $invalidProperties[] = "'main_image' can't be null";
        }
        if ($this->container['qty'] === null) {
            $invalidProperties[] = "'qty' can't be null";
        }
        if ($this->container['stock_qty'] === null) {
            $invalidProperties[] = "'stock_qty' can't be null";
        }
        if ($this->container['price'] === null) {
            $invalidProperties[] = "'price' can't be null";
        }
        if ($this->container['price_per_one'] === null) {
            $invalidProperties[] = "'price_per_one' can't be null";
        }
        if ($this->container['cost'] === null) {
            $invalidProperties[] = "'cost' can't be null";
        }
        if ($this->container['cost_per_one'] === null) {
            $invalidProperties[] = "'cost_per_one' can't be null";
        }
        if ($this->container['discount'] === null) {
            $invalidProperties[] = "'discount' can't be null";
        }
        if ($this->container['discount_per_one'] === null) {
            $invalidProperties[] = "'discount_per_one' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets offer_id
     *
     * @return int
     */
    public function getOfferId()
    {
        return $this->container['offer_id'];
    }

    /**
     * Sets offer_id
     *
     * @param int $offer_id ID оффера
     *
     * @return $this
     */
    public function setOfferId($offer_id)
    {


        /*if (is_null($offer_id)) {
            throw new \InvalidArgumentException('non-nullable offer_id cannot be null');
        }*/
        $this->container['offer_id'] = $offer_id;

        return $this;
    }

    /**
     * Gets product_id
     *
     * @return int
     */
    public function getProductId()
    {
        return $this->container['product_id'];
    }

    /**
     * Sets product_id
     *
     * @param int $product_id ID товара
     *
     * @return $this
     */
    public function setProductId($product_id)
    {


        /*if (is_null($product_id)) {
            throw new \InvalidArgumentException('non-nullable product_id cannot be null');
        }*/
        $this->container['product_id'] = $product_id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string $name Название товара
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets code
     *
     * @return string
     */
    public function getCode()
    {
        return $this->container['code'];
    }

    /**
     * Sets code
     *
     * @param string $code Код товара (выводится в URL)
     *
     * @return $this
     */
    public function setCode($code)
    {


        /*if (is_null($code)) {
            throw new \InvalidArgumentException('non-nullable code cannot be null');
        }*/
        $this->container['code'] = $code;

        return $this;
    }

    /**
     * Gets barcode
     *
     * @return string|null
     */
    public function getBarcode()
    {
        return $this->container['barcode'];
    }

    /**
     * Sets barcode
     *
     * @param string|null $barcode Штрихкод (EAN)
     *
     * @return $this
     */
    public function setBarcode($barcode)
    {

        if (is_null($barcode)) {
            array_push($this->openAPINullablesSetToNull, 'barcode');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('barcode', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['barcode'] = $barcode;

        return $this;
    }

    /**
     * Gets vendor_code
     *
     * @return string|null
     */
    public function getVendorCode()
    {
        return $this->container['vendor_code'];
    }

    /**
     * Sets vendor_code
     *
     * @param string|null $vendor_code Артикул
     *
     * @return $this
     */
    public function setVendorCode($vendor_code)
    {

        if (is_null($vendor_code)) {
            array_push($this->openAPINullablesSetToNull, 'vendor_code');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('vendor_code', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['vendor_code'] = $vendor_code;

        return $this;
    }

    /**
     * Gets type
     *
     * @return int
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param int $type Тип товара
     *
     * @return $this
     */
    public function setType($type)
    {


        /*if (is_null($type)) {
            throw new \InvalidArgumentException('non-nullable type cannot be null');
        }*/
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets is_adult
     *
     * @return bool|null
     */
    public function getIsAdult()
    {
        return $this->container['is_adult'];
    }

    /**
     * Sets is_adult
     *
     * @param bool|null $is_adult Товар 18+
     *
     * @return $this
     */
    public function setIsAdult($is_adult)
    {

        if (is_null($is_adult)) {
            array_push($this->openAPINullablesSetToNull, 'is_adult');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('is_adult', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['is_adult'] = $is_adult;

        return $this;
    }

    /**
     * Gets uom
     *
     * @return int|null
     */
    public function getUom()
    {
        return $this->container['uom'];
    }

    /**
     * Sets uom
     *
     * @param int|null $uom Единица измерения весового товара
     *
     * @return $this
     */
    public function setUom($uom)
    {

        if (is_null($uom)) {
            array_push($this->openAPINullablesSetToNull, 'uom');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('uom', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['uom'] = $uom;

        return $this;
    }

    /**
     * Gets tariffing_volume
     *
     * @return int|null
     */
    public function getTariffingVolume()
    {
        return $this->container['tariffing_volume'];
    }

    /**
     * Sets tariffing_volume
     *
     * @param int|null $tariffing_volume Единица тарификации весового товара
     *
     * @return $this
     */
    public function setTariffingVolume($tariffing_volume)
    {

        if (is_null($tariffing_volume)) {
            array_push($this->openAPINullablesSetToNull, 'tariffing_volume');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('tariffing_volume', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['tariffing_volume'] = $tariffing_volume;

        return $this;
    }

    /**
     * Gets order_step
     *
     * @return float|null
     */
    public function getOrderStep()
    {
        return $this->container['order_step'];
    }

    /**
     * Sets order_step
     *
     * @param float|null $order_step Шаг пикера
     *
     * @return $this
     */
    public function setOrderStep($order_step)
    {

        if (is_null($order_step)) {
            array_push($this->openAPINullablesSetToNull, 'order_step');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('order_step', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['order_step'] = $order_step;

        return $this;
    }

    /**
     * Gets order_minvol
     *
     * @return float|null
     */
    public function getOrderMinvol()
    {
        return $this->container['order_minvol'];
    }

    /**
     * Sets order_minvol
     *
     * @param float|null $order_minvol Минимальное количество для заказа
     *
     * @return $this
     */
    public function setOrderMinvol($order_minvol)
    {

        if (is_null($order_minvol)) {
            array_push($this->openAPINullablesSetToNull, 'order_minvol');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('order_minvol', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['order_minvol'] = $order_minvol;

        return $this;
    }

    /**
     * Gets main_image
     *
     * @return string|null
     */
    public function getMainImage()
    {
        return $this->container['main_image'];
    }

    /**
     * Sets main_image
     *
     * @param string|null $main_image URL основной картинки
     *
     * @return $this
     */
    public function setMainImage($main_image)
    {

        if (is_null($main_image)) {
            array_push($this->openAPINullablesSetToNull, 'main_image');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('main_image', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['main_image'] = $main_image;

        return $this;
    }

    /**
     * Gets qty
     *
     * @return float
     */
    public function getQty()
    {
        return $this->container['qty'];
    }

    /**
     * Sets qty
     *
     * @param float $qty Кол-во товара
     *
     * @return $this
     */
    public function setQty($qty)
    {


        /*if (is_null($qty)) {
            throw new \InvalidArgumentException('non-nullable qty cannot be null');
        }*/
        $this->container['qty'] = $qty;

        return $this;
    }

    /**
     * Gets stock_qty
     *
     * @return int
     */
    public function getStockQty()
    {
        return $this->container['stock_qty'];
    }

    /**
     * Sets stock_qty
     *
     * @param int $stock_qty Сток по товару
     *
     * @return $this
     */
    public function setStockQty($stock_qty)
    {


        /*if (is_null($stock_qty)) {
            throw new \InvalidArgumentException('non-nullable stock_qty cannot be null');
        }*/
        $this->container['stock_qty'] = $stock_qty;

        return $this;
    }

    /**
     * Gets price
     *
     * @return int
     */
    public function getPrice()
    {
        return $this->container['price'];
    }

    /**
     * Sets price
     *
     * @param int $price Цена товара (цена * qty - скидки) (в коп.)
     *
     * @return $this
     */
    public function setPrice($price)
    {


        /*if (is_null($price)) {
            throw new \InvalidArgumentException('non-nullable price cannot be null');
        }*/
        $this->container['price'] = $price;

        return $this;
    }

    /**
     * Gets price_per_one
     *
     * @return int
     */
    public function getPricePerOne()
    {
        return $this->container['price_per_one'];
    }

    /**
     * Sets price_per_one
     *
     * @param int $price_per_one Цена единичного товара (в коп.)
     *
     * @return $this
     */
    public function setPricePerOne($price_per_one)
    {


        /*if (is_null($price_per_one)) {
            throw new \InvalidArgumentException('non-nullable price_per_one cannot be null');
        }*/
        $this->container['price_per_one'] = $price_per_one;

        return $this;
    }

    /**
     * Gets cost
     *
     * @return int
     */
    public function getCost()
    {
        return $this->container['cost'];
    }

    /**
     * Sets cost
     *
     * @param int $cost Цена товара до скидок (цена * qty) (в коп.)
     *
     * @return $this
     */
    public function setCost($cost)
    {


        /*if (is_null($cost)) {
            throw new \InvalidArgumentException('non-nullable cost cannot be null');
        }*/
        $this->container['cost'] = $cost;

        return $this;
    }

    /**
     * Gets cost_per_one
     *
     * @return int
     */
    public function getCostPerOne()
    {
        return $this->container['cost_per_one'];
    }

    /**
     * Sets cost_per_one
     *
     * @param int $cost_per_one Цена единичного товара до скидок (в коп.)
     *
     * @return $this
     */
    public function setCostPerOne($cost_per_one)
    {


        /*if (is_null($cost_per_one)) {
            throw new \InvalidArgumentException('non-nullable cost_per_one cannot be null');
        }*/
        $this->container['cost_per_one'] = $cost_per_one;

        return $this;
    }

    /**
     * Gets discount
     *
     * @return int
     */
    public function getDiscount()
    {
        return $this->container['discount'];
    }

    /**
     * Sets discount
     *
     * @param int $discount Скидка по товару (скидка * qty) (в коп.)
     *
     * @return $this
     */
    public function setDiscount($discount)
    {


        /*if (is_null($discount)) {
            throw new \InvalidArgumentException('non-nullable discount cannot be null');
        }*/
        $this->container['discount'] = $discount;

        return $this;
    }

    /**
     * Gets discount_per_one
     *
     * @return int
     */
    public function getDiscountPerOne()
    {
        return $this->container['discount_per_one'];
    }

    /**
     * Sets discount_per_one
     *
     * @param int $discount_per_one Скидка единичного товара (в коп.)
     *
     * @return $this
     */
    public function setDiscountPerOne($discount_per_one)
    {


        /*if (is_null($discount_per_one)) {
            throw new \InvalidArgumentException('non-nullable discount_per_one cannot be null');
        }*/
        $this->container['discount_per_one'] = $discount_per_one;

        return $this;
    }

    /**
     * Gets discounts
     *
     * @return \Ensi\BasketsClient\Dto\Discount[]|null
     */
    public function getDiscounts()
    {
        return $this->container['discounts'];
    }

    /**
     * Sets discounts
     *
     * @param \Ensi\BasketsClient\Dto\Discount[]|null $discounts discounts
     *
     * @return $this
     */
    public function setDiscounts($discounts)
    {


        /*if (is_null($discounts)) {
            throw new \InvalidArgumentException('non-nullable discounts cannot be null');
        }*/
        $this->container['discounts'] = $discounts;

        return $this;
    }

    /**
     * Gets images
     *
     * @return \Ensi\BasketsClient\Dto\ProductImage[]|null
     */
    public function getImages()
    {
        return $this->container['images'];
    }

    /**
     * Sets images
     *
     * @param \Ensi\BasketsClient\Dto\ProductImage[]|null $images images
     *
     * @return $this
     */
    public function setImages($images)
    {


        /*if (is_null($images)) {
            throw new \InvalidArgumentException('non-nullable images cannot be null');
        }*/
        $this->container['images'] = $images;

        return $this;
    }

    /**
     * Gets brand
     *
     * @return \Ensi\BasketsClient\Dto\Brand|null
     */
    public function getBrand()
    {
        return $this->container['brand'];
    }

    /**
     * Sets brand
     *
     * @param \Ensi\BasketsClient\Dto\Brand|null $brand brand
     *
     * @return $this
     */
    public function setBrand($brand)
    {


        /*if (is_null($brand)) {
            throw new \InvalidArgumentException('non-nullable brand cannot be null');
        }*/
        $this->container['brand'] = $brand;

        return $this;
    }

    /**
     * Gets nameplates
     *
     * @return \Ensi\BasketsClient\Dto\Nameplate[]|null
     */
    public function getNameplates()
    {
        return $this->container['nameplates'];
    }

    /**
     * Sets nameplates
     *
     * @param \Ensi\BasketsClient\Dto\Nameplate[]|null $nameplates nameplates
     *
     * @return $this
     */
    public function setNameplates($nameplates)
    {


        /*if (is_null($nameplates)) {
            throw new \InvalidArgumentException('non-nullable nameplates cannot be null');
        }*/
        $this->container['nameplates'] = $nameplates;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


